﻿--
-- adds handBrake to all Vehicles that have the "steerable" specialization.
--
--
-- author:    	Xentro (www.ls-uk.info)(Marcus@Xentro.se)
-- @version:    v1.0
-- @date:       2012-10-26
-- @history:    v1.0 - inital implementation
-- 
--
SpecializationUtil.registerSpecialization("handBrake", "handBrake", g_currentModDirectory .. "handBrake.lua")

register_handBrake = {}

function register_handBrake:loadMap(name)
	if self.firstRun == nil then
		self.firstRun = false;
		print(":: Loading specialization :: HandBrake ::");
		
		for k, v in pairs(VehicleTypeUtil.vehicleTypes) do  
			if v ~= nil then
				local doRegister = false;
				for i = 1, table.maxn(v.specializations) do
					local vs = v.specializations[i];
					if vs ~= nil and vs == SpecializationUtil.getSpecialization("steerable") then
--						print("Load specialization HandBrake: " .. tostring(v.name));
						table.insert(v.specializations, SpecializationUtil.getSpecialization("handBrake"));
						vs.handbrake_ON = g_i18n:getText("handbrakeON");
						vs.handbrake_OFF = g_i18n:getText("handbrakeOFF");
--						vs.handbrake_RELEASE = g_i18n:getText("handbrakeRELEASE");
--						vs.handBrakeHud = Overlay:new("hBOverlay", Utils.getFilename("hb_symbol.dds", g_currentModDirectory), 0.729, 0.172, 0.025, 0.0425);
					end;
				end;	
			end;
		end;
	end;
end;

function register_handBrake:deleteMap()
end;

function register_handBrake:keyEvent(unicode, sym, modifier, isDown)
end;

function register_handBrake:mouseEvent(posX, posY, isDown, isUp, button)
end;

function register_handBrake:update(dt)
end;

function register_handBrake:draw()
end;

addModEventListener(register_handBrake);